{ 2004-12-18 programmeerimisvistlus                                        }
{ lesanne: ALAMJADA (algajate rhm)                                        }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

{ Ebaefektiivne lahendus. }

const
   sisf = 'AJADA.SIS';                                   { sisendfaili nimi }
   valf = 'AJADA.VAL';                                  { vljundfaili nimi }
   maxn = 1000;                            { maksimaalne lubatud jadapikkus }

var
   n : integer;                                               { jada pikkus }
   a : array [1..maxn] of integer;                               { jada ise }
   ii, jj : integer;                        { leitud alamjada algus ja lpp }

procedure loe_sisend;
var f : text; i : integer;
begin
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do
      read(f, a[i]);
   close(f);
end;

procedure leia_pikim;
var i, j : integer;
begin
   ii := 0; jj := 0;                                   { algseis: jada pole }
   for i := 1 to n do begin    { vaatleme kiki vimalikke alguspositsioone }
      { leiame pikima elemendist a[i] algava kasvava alamjada }
      j := i;
      while (j < n) and (a[j] < a[j + 1]) do
         j := j + 1;
      { a[i..j] on kasvav alamjada, a[i..j+1] enam ei ole }
      if j - i >= jj - ii then begin               { kui on uus maksimaalne }
         ii := i; jj := j;                                  { jtame meelde }
      end;
   end;
end;

procedure tee_valjund;
var f : text; i : integer;
begin
   assign(f, valf); rewrite(f);
   writeln(f, jj - ii + 1);
   for i := ii to jj do
      if i < jj then
         write(f, a[i], ' ')
      else
         writeln(f, a[i]);
   close(f);
end;

begin
   loe_sisend;
   leia_pikim;
   tee_valjund;
end.
