{ 2004-12-18 programmeerimisvistlus                                        }
{ lesanne: ALAMJADA (algajate rhm)                                        }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

const
   sisf = 'AJADA.SIS';                                   { sisendfaili nimi }
   valf = 'AJADA.VAL';                                  { vljundfaili nimi }
   maxn = 1000;                            { maksimaalne lubatud jadapikkus }

var
   n : integer;                                               { jada pikkus }
   a : array [1..maxn] of integer;                               { jada ise }
   ii, jj : integer;                        { leitud alamjada algus ja lpp }

procedure loe_sisend;
var f : text; i : integer;
begin
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do
      read(f, a[i]);
   close(f);
end;

procedure leia_pikim;
var i, j : integer;
begin
   ii := 0; jj := 0;                                   { algseis: jada pole }
   i := 1;                                     { kasvav alamjada algab siit }
   for j := 1 to n - 1 do          { vrdleme iga elementi talle jrgnevaga }
      if a[j] >= a[j + 1] then begin         { kui on kasvava alamjada lpp }
         if j - i >= jj -ii then begin             { kui on uus maksimaalne }
            ii := i; jj := j;                               { jtame meelde }
         end;
         i := j + 1;               { uus kasvav algab jrgmisest elemendist }
      end;
   if n - i >= jj - ii then begin        { a[n] on ka kasvava alamjada lpp }
      ii := i; jj := n;
   end;
end;

procedure tee_valjund;
var f : text; i : integer;
begin
   assign(f, valf); rewrite(f);
   writeln(f, jj - ii + 1);
   for i := ii to jj do
      if i < jj then
         write(f, a[i], ' ')
      else
         writeln(f, a[i]);
   close(f);
end;

begin
   loe_sisend;
   leia_pikim;
   tee_valjund;
end.
