{ 2004-12-18 programmeerimisvistlus                                        }
{ lesanne: SIRGLIK (algajate rhm)                                        }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

const
   sisf = 'ALOIK.SIS';                                   { sisendfaili nimi }
   valf = 'ALOIK.VAL';                                  { valjundfaili nimi }

var
   xa, ya, xb, yb : integer;               { ligu otspunktide koordinaadid }
   v : array [1..4] of boolean;                        { veerandite massiiv }

procedure loe_sisend;
var f : text;
begin
   assign(f, sisf); reset(f);
   readln(f, xa, ya);
   readln(f, xb, yb);
   close(f);
end;

procedure uuri_loiku(x1, y1, x2, y2 : real);
var r : real;
begin
   if x1 * x2 < 0 then begin                { kui teine teisel pool y-telge }
      r := (x1 * y2 - x2 * y1) / (x1 - x2);
      uuri_loiku(x1, y1, 0, r);
      uuri_loiku(0, r, x2, y2);
   end else if y1 * y2 < 0 then begin       { kui teine teisel pool x-telge }
      r := (y1 * x2 - y2 * x1) / (y1 - y2);
      uuri_loiku(x1, y1, r, 0);
      uuri_loiku(r, 0, x2, y2);
   end else begin                               { terve lik hes veerandis }
      if (x1 + x2 > 0) and (y1 + y2 > 0) then
         v[1] := true;
      if (x1 + x2 < 0) and (y1 + y2 > 0) then
         v[2] := true;
      if (x1 + x2 < 0) and (y1 + y2 < 0) then
         v[3] := true;
      if (x1 + x2 > 0) and (y1 + y2 < 0) then
         v[4] := true;
   end;
end;

procedure leia_veerandid;
var i : integer;
begin
   for i := 1 to 4 do
      v[i] := false;
   uuri_loiku(xa, ya, xb, yb);
end;

procedure tee_valjund;
var f : text; i : integer;
begin
   assign(f, valf); rewrite(f);
   for i := 1 to 4 do
      if v[i] then
         writeln(f, 'JAH')
      else
         writeln(f, 'EI');
   close (f);
end;

begin
   loe_sisend;
   leia_veerandid;
   tee_valjund;
end.
