{ 2004-12-18 programmeerimisvistlus                                        }
{ lesanne: ALAMJADA (edasijudnute rhm)                                   }
{ Autor: Ahto Truu                                                          }
{ Testitud: FPC 1.0.10 / Win32                                              }

const
   sisf = 'EJADA.SIS';                                   { sisendfaili nimi }
   valf = 'EJADA.VAL';                                  { vljundfaili nimi }
   maxn = 1000;                            { maksimaalne lubatud jadapikkus }

type
   elem = record                                       { jada elemendi info }
      a : integer;                                                { element }
      i : integer;                            { tema indeks esialgses jadas }
   end;

var
   n : integer;                                               { jada pikkus }
   a : array [1..maxn] of elem;                                  { jada ise }
   k : integer;                                    { leitud alamjada pikkus }

procedure loe_sisend;
var f : text; i : integer;
begin
   assign(f, sisf); reset(f);
   readln(f, n);
   for i := 1 to n do begin
      read(f, a[i].a);
      a[i].i := i;
   end;
   close(f);
end;

procedure leia_jada_pikkus;
var i, j : integer; x : elem;
begin
   for i := 1 to n do begin
      { pistame elemendi juba sorteeritute vahele }
      j := i;
      while j > 1 do
         if a[j].a < a[j - 1].a then begin
            x := a[j]; a[j] := a[j - 1]; a[j - 1] := x;
            j := j - 1;
         end else
            j := 0;
      { kontrollime, kas alamjada on aritmeetilne jada }
      j := i;
      while j > 2 do
         if a[j].a - a[j - 1].a = a[j - 1].a - a[j - 2].a then
            j := j - 1
         else
            j := 0;
      { kui oli, jtame pikkuse meelde }
      if j > 0 then
         k := i;
   end;
end;

procedure tee_valjund;
var f : text; i, j : integer;
begin
   assign(f, valf); rewrite(f);
   writeln(f, k);
   j := 0;
   for i := 1 to n do
      { kas jooksev element oli esialgse jada K esimese hulgas }
      if a[i].i <= k then begin
         j := j + 1;
         if j < k then
            write(f, a[i].a, ' ')
         else
            writeln(f, a[i].a);
      end;
   close(f);
end;

begin
   loe_sisend;
   leia_jada_pikkus;
   tee_valjund;
end.
